local M = {}

--[[
This file simply passes the call from BeamNG to the controller file
The controller file exists so that variables are not reset on scenario reset
]]--

local controller = require("scenario/intersection/controller")
local setup = false

local function onPreRender(dt)
    if not setup then
        return
    end

    controller.onPreRender(dt)
end

local function onScenarioChange(sc)
    controller.onScenarioChange(sc)

    if sc and sc.state == "pre-running" then
        setup = true
    end
end
local function onRaceStart()                 controller.onRaceStart()                 end
local function onCountdownStarted()          controller.onCountdownStarted()          end
local function onBeamNGTrigger(data)         controller.onBeamNGTrigger(data)         end
local function onScenarioRestarted()         controller.onScenarioRestarted()         end
local function onObjectCollision(id1, id2)   controller.onObjectCollision(id1, id2)   end

M.onPreRender         = onPreRender
M.onRaceStart         = onRaceStart
M.onScenarioChange    = onScenarioChange
M.onCountdownStarted  = onCountdownStarted
M.onBeamNGTrigger     = onBeamNGTrigger
M.onScenarioRestarted = onScenarioRestarted
M.onObjectCollision   = onObjectCollision
return M
