------------------------------------------------------------------------------------------------------------------
--Imports
----------------------------------------------------------------------------------------------------

local ClassPickup                 = require("scenario/intersection/classes/pickups/classPickup")
local ClassArmageddonCrashbreaker = require("scenario/intersection/classes/crashbreaker/classArmageddon")
local classHelper                 = require("scenario/intersection/classHelper")
local soundHandler                = require("scenario/intersection/handlers/soundHandler")

----------------------------------------------------------------------------------------------------

local ClassArmageddonPickup = classHelper.inheritsFrom(ClassPickup)

----------------------------------------------------------------------------------------------------
--Static Attributes
----------------------------------------------------------------------------------------------------

ClassArmageddonPickup.className = "ClassArmageddonPickup"

----------------------------------------------------------------------------------------------------
--Overridden Methods
--See superclass for method descriptions
----------------------------------------------------------------------------------------------------

function ClassArmageddonPickup:collect(crashbreaker)
    --[[
    See ClassPickup:collect()
    Parameters:
        crashbreaker - the crashbreaker instance for the scenario to upgrade
    Returns:
        <ClassArmageddonCrashbreaker> - the upgraded crashbreaker
    ]]--
    ClassPickup.collect(self)

    soundHandler.play("armageddon_pickup")
    return crashbreaker:convert(ClassArmageddonCrashbreaker, crashbreaker)
end

----------------------------------------------------------------------------------------------------
--Constructor
----------------------------------------------------------------------------------------------------

function ClassArmageddonPickup:new(position)
    --[[
    Parameters:
        position - the position of the pickup
    ]]--
    local self = ClassPickup:new(position, "armageddon")
    self.value = "armageddon"

    setmetatable(self, {__index = ClassArmageddonPickup})
    return self
end

------------------------------------------------------------------------------------------------------------------
--Interface
----------------------------------------------------------------------------------------------------

return ClassArmageddonPickup