----------------------------------------------------------------------------------------------------
--Imports
----------------------------------------------------------------------------------------------------

local ClassVehicle = require("scenario/intersection/classes/vehicles/classVehicle")
local classHelper  = require("scenario/intersection/classHelper")

----------------------------------------------------------------------------------------------------

local ClassPlayer = classHelper.inheritsFrom(ClassVehicle)

-------------------------------------------------------------------------------------------------------
--Static Attributes
----------------------------------------------------------------------------------------------------

ClassPlayer.className = "ClassPlayer"
--Override the inherited value to prevent this object counting as a collision
ClassPlayer.MAX_DAMAGE_SCORE = 0

----------------------------------------------------------------------------------------------------
--Overridden Methods
----------------------------------------------------------------------------------------------------

function ClassPlayer:getDamageScore()
    return 0
end

function ClassPlayer:reset()
    ClassVehicle.reset(self)
    self:resetHeadLights()
end

----------------------------------------------------------------------------------------------------
--Instance Methods
----------------------------------------------------------------------------------------------------

function ClassPlayer:resetHeadLights()
    --[[
    Resets the headlights to off
    ]]--
    self.obj:queueLuaCommand('electrics.setLightsState(0)')
end

----------------------------------------------------------------------------------------------------
--Constructor
----------------------------------------------------------------------------------------------------

function ClassPlayer:new(id, name, position)
    --[[
    See ClassVehicle:new()
    ]]--
    local self = ClassVehicle:new(id, name, position)

    setmetatable(self, {__index = ClassPlayer})
    return self
end

----------------------------------------------------------------------------------------------------
--Interface
----------------------------------------------------------------------------------------------------

return ClassPlayer
