----------------------------------------------------------------------------------------------------
--Imports
----------------------------------------------------------------------------------------------------

local ClassVehicle = require("scenario/intersection/classes/vehicles/classVehicle")
local classHelper  = require("scenario/intersection/classHelper")

----------------------------------------------------------------------------------------------------

local ClassProp = classHelper.inheritsFrom(ClassVehicle)

-------------------------------------------------------------------------------------------------------
--Static Attributes
----------------------------------------------------------------------------------------------------

ClassProp.className = "ClassProp"
--Override the inherited value to prevent this object counting as a collision
ClassProp.MAX_DAMAGE_SCORE = 0

----------------------------------------------------------------------------------------------------
--Overridden Methods
----------------------------------------------------------------------------------------------------

function ClassProp:getDamageScore()
    return 0
end

----------------------------------------------------------------------------------------------------
--Constructor
----------------------------------------------------------------------------------------------------

function ClassProp:new(id, name, position)
    --[[
    See ClassVehicle:new()
    ]]--
    local self = ClassVehicle:new(id, name, position)

    setmetatable(self, {__index = ClassProp})
    return self
end

----------------------------------------------------------------------------------------------------
--Interface
----------------------------------------------------------------------------------------------------

return ClassProp