local M = {}

local errorHandler = require("scenario/intersection/handlers/errorHandler")

local function format(str)
    --[[
    Formats a string
    Exmaple: word_word2 -> Word_Word2
    Parameters:
        str - the string to format
    Returns:
        <string> - the formatted string
    ]]--
    local formatted = ""

    for word in str:gmatch("[^_]+") do
        formatted = formatted .. word:sub(1,1):upper()..word:sub(2) .. "_"
    end

    --Remove last _ from end
    return formatted:sub(1,#formatted-1)
end

local function play(event)
    --[[
    Plays the sound corresponding to the event
    Parameters:
        event - the event name
    ]]--
    errorHandler.assertNil(event)

    event = format(event)

    local speed = bullettime.get() == 1 and "" or "_BT"

    Engine.Audio.playOnce("AudioGui", "event:I_"..event..speed)
end


M.play = play
return M