angular.module('beamng.apps')
.directive('intersectionCrashbreaker', [function () {
  return {
    template:
        '<div class="bngApp" style="font-family:Fantasy,fantasy; background:transparent;">'
      +      '<link type="text/css" rel="stylesheet" href="modules/intersection/apps/style.css">'
      +      '<link type="text/css" rel="stylesheet" href="modules/intersection/apps/Crashbreaker/app.css">'
      +      '<div class="crashbreaker" style="width:700px;">'
      +          '<span class="flame" id="cbText">CRASHBREAKER</span>'
      +          '<span class="minor" id="in">&nbsp in &nbsp</span>'
      +          '<span id="requirement"></span>'
      +      '</div>'
      + '</div>',
    replace: true,
    link: function (scope) {
        'use strict';


        /**
         * Removes the 'in' text and also flash the UI
         */
        function onRequirementReached() {
            document.getElementById("in").innerHTML = "&nbsp&nbsp";

            let req = document.getElementById("requirement");
            req.innerHTML = "";
            req.style.color = "yellow";
            req.style.animation = "shadowPulse 2s infinite linear";

            let cbText = document.getElementById("cbText");
            cbText.style.animation = "shadowPulse 2s infinite linear";
            cbText.style.filter = "saturate(5)";
        }

        /**
         * Upgrades the crashbreaker to an armageddon crashbreaker
         */
        scope.$on('i_crashbreaker_upgrade', function (event, data) {
            let cbText = document.getElementById("cbText");
            cbText.innerHTML = "ARMAGEDDON";
            cbText.className = "extremeFlame";
        });

        /**
         * Updates the score displayed
         * @param {Object} data - should contain
         *          {int} requirement - the amount of vehicles needed to get a crashbreaker
                    OR
                    {boolean} used    - whether the player used the crashbreaker
         */
        scope.$on('i_crashbreaker_update', function (event, data) {
            let req = document.getElementById("requirement");
            let cbText = document.getElementById("cbText");

            if (data.used) {
                // Grey out and stop animating
                cbText.style.filter = "grayscale(100%)";
                cbText.style.animation = "none";
                req.innerHTML = "";
                req.style.animation = "none";
            } else if (data.requirement <= 0) {
                onRequirementReached();
            } else {
                // Update the element's value
                req.innerHTML = data.requirement;
            }
        });
    }
  };
}]);
