angular.module('beamng.apps')
  .directive('intersectionPickup', [function () {
    return {
      template:
        '<div class="bngApp" style="background:transparent">'
        + '<link type="text/css" rel="stylesheet" href="modules/intersection/apps/Pickup/app.css">'
        + '<table id="pickups"></table>'
        + '</div>',
      replace: true,
      link: function (scope) {
        'use strict';

        scope.pickups = [];

        function resetValues() {
          scope.$evalAsync(function () {
            scope.pickups = [];
          });
        }

        /**
         * Adds in a new row at the top for the new pickup
         * @param {Object} data - should contain:
                    {string} pickup - the pickup collected
         */
        scope.$on('i_pickup_add', function (event, data) {
          let pickup = data.pickup;

          // Don't show up on the pickup UI
          if (pickup === "explosive" || pickup === "armageddon") {
            return;
          }

          let newRow = document.getElementById("pickups").insertRow(0);
          newRow.id = pickup;

          let cell = newRow.insertCell(0);
          cell.innerHTML = "<img id='img_" + pickup + "' width='80px' height='80px' src='modules/intersection/images/pickups/" + pickup + ".png' alt=''>";

          // Add into memory
          scope.pickups.push(pickup);
        });

        scope.$on('ScenarioResetTimer', resetValues);
      }
    };
  }]);

