angular.module('beamng.apps')
  .directive('intersectionScoring', [function () {
    return {
      template:
        '<div class="bngApp" style="font-family:Fantasy,fantasy; background:transparent;">'
        + '<link type="text/css" rel="stylesheet" href="modules/intersection/apps/Scoring/app.css">'
        + '<div class="score" style="width:450px;">'
        + '<span class="title">Damage</span>'
        + '<span class="value">'
        + '<img src="modules/intersection/images/currency.png" width="24px" height="48px" alt="">'
        + '&nbsp'
        + '<span id="scoreVal">0</span>'
        + '</span>'
        + '</div>'
        + '<div class="multiplier" style="width:350px;">'
        + '<span class="title">Col. Multi</span>'
        + '<span class="value" id="multiVal">1.0x</span>'
        + '</div>'
        + '<div class="vehicles" style="width:300px;">'
        + '<span class="title">Vehicles</span>'
        + '<span class="value" id="vehicleVal">0 / 0'
        + '</span>'
        + '</div>'
        + '</div>',
      replace: true,
      link: function (scope) {
        'use strict';

        scope.totalVehicles = 0;
        scope.crashedVehicles = 0;

        function resetValues() {
          scope.$evalAsync(function () {
            scope.totalVehicles = 0;
            scope.crashedVehicles = 0;
          });
        }

        /**
         * Updates the vehicles crashed bar
         */
        function updateVehiclesCrashed() {
          document.getElementById("vehicleVal").innerHTML = scope.crashedVehicles + " / " + scope.totalVehicles;
        }

        /**
         * Counts another vehicle as crashed and displays it
         */
        scope.$on('i_scoring_add_vehicle', function () {
          scope.crashedVehicles++;
          updateVehiclesCrashed();
        });

        /**
         * Updates the score displayed
         * @param data - should contain:
                    score      - the new score
                    multiplier - the new multiplier
         */
        scope.$on('i_scoring_update', function (event, data) {
          document.getElementById("scoreVal").innerHTML = "" + Math.floor(data.score);
          document.getElementById("multiVal").innerHTML = data.multiplier.toLocaleString(undefined, 1) + "x";
        });

        scope.$on('i_scoring_init', function (event, data) {
          scope.$evalAsync(function () {
            scope.totalVehicles = data.vehicles;
            updateVehiclesCrashed();
          });
        });

        scope.$on('ScenarioResetTimer', resetValues);
      }
    };
  }]);
